/* http://keith-wood.name/imageCube.html
   Image Cube for jQuery v1.1.0.
   Written by Keith Wood (kbwood@virginbroadband.com.au) June 2008.
   Dual licensed under the GPL (http://dev.jquery.com/browser/trunk/jquery/GPL-LICENSE.txt) and 
   MIT (http://dev.jquery.com/browser/trunk/jquery/MIT-LICENSE.txt) licenses. 
   Please attribute the author if you use it. */
(function($){function ImageCube(){this._defaults={direction:'random',randomSelection:['up','down','left','right'],speed:2000,easing:'linear',noShading:false,imagePath:'',repeat:true,selection:'forward',pause:2000,opacity:[0.0,0.8],lineHeight:[0.0,1.25],letterSpacing:[-0.4,0.0]}};var B=0;var C=1;var D=2;var E=3;var F='imageCube';$.extend(ImageCube.prototype,{markerClassName:'hasImageCube',setDefaults:function(a){extendRemove(this._defaults,a||{})},_attachImageCube:function(b,c){b=$(b);if(b.is('.'+this.markerClassName)){return}b.addClass(this.markerClassName);var d=$.extend({},this._defaults,c||{});$.data(b[0],F,d);b.children().each(function(){var a=$(this);$.data(this,F,{width:a.css('width'),height:a.css('height'),position:a.css('position'),lineHeight:a.css('lineHeight'),letterSpacing:a.css('letterSpacing')});a.css({width:b.css('width'),height:b.css('height'),position:'absolute',lineHeight:d.lineHeight[1],letterSpacing:d.letterSpacing[1]})}).not(':first').hide();this._prepareRotation(b[0])},_prepareRotation:function(a){a=$(a);var b=$.data(a[0],F);b.current=a.children(':visible')[0];if(b.repeat&&!b._timer){if(!a[0].id){a[0].id='ic'+new Date().getTime()}b._timer=setTimeout('jQuery.imagecube._rotateImageCube("#'+a[0].id+'")',b.pause)}$.data(a[0],F,b)},_rotateImageCube:function(a,b){a=$(a);this._stopImageCube(a[0],true);var c=$.data(a[0],F);var d={};d[F]=1.0;a.attr(F,0.0).animate(d,c.speed,c.easing,b)},_currentImageCube:function(a){return $.data(a,F).current},_stopImageCube:function(a,b){var c=$.data(a,F);if(c._timer){clearTimeout(c._timer);c._timer=null}if(!b){c.repeat=false}$.data(a,F,c)},_startImageCube:function(a){this._changeImageCube(a,{repeat:true})},_changeImageCube:function(a,b){var c=$.data(a,F);extendRemove(c||{},b||{});$.data(a,F,c);this._prepareRotation(a)},_destroyImageCube:function(a){this._stopImageCube(a);a=$(a);if(!a.is('.'+this.markerClassName)){return}a.stop().removeClass(this.markerClassName).children('.imageCubeShading').remove();a.children().each(function(){$(this).css($.data(this,F)).show();$.removeData(this,F)});$.removeData(a[0],F)},_prepareImageCube:function(d){var e=$.data(d,F);var d=$(d);var f=false;var g=function(a){return(!a.length?a:a.filter(':eq('+Math.floor(Math.random()*a.length)+')'))};var h=d.children(':visible');var j=(e.selection=='random'?g(d.children(':hidden')):(e.selection=='backward'?h.prev():h.next()));j=(j.length?j:(e.selection=='random'?h:(e.selection=='backward'?d.children(':last'):d.children(':first'))));var k=d.offset();d.parents().each(function(){var a=$(this);if(a.css('position')=='fixed'){k.left-=a.offset().left;k.top-=a.offset().top;return false}});var l={width:d.width(),height:d.height()};var m=(e.direction!='random'?e.direction:e.randomSelection[Math.floor(Math.random()*e.randomSelection.length)]);m=Math.max(0,$.inArray(m,['up','down','left','right']));var n=(m==B||m==C);var o=(m==D||m==E);var q=(m==B||m==D);var r=(q?e.opacity[0]:e.opacity[1]);var s=[];var t=function(p){var b=[];for(var i=0;i<4;i++){b[i]=p.css('border'+['Left','Right','Top','Bottom'][i]+'Width');var a=parseFloat(b[i]);b[i]=(!isNaN(a)?a:Math.max(0,$.inArray(b[i],['thin','medium','thick'])*2+1))}return b};s[0]=t(h);s[1]=t(j);var u=[];u[0]=[parseFloat(h.css('padding-left')),parseFloat(h.css('padding-right')),parseFloat(h.css('padding-top')),parseFloat(h.css('padding-bottom'))];u[1]=[parseFloat(j.css('padding-left')),parseFloat(j.css('padding-right')),parseFloat(j.css('padding-top')),parseFloat(j.css('padding-bottom'))];var v=[];v[0]=[($.boxModel?s[0][0]+s[0][1]+u[0][0]+u[0][1]:0),($.boxModel?s[0][2]+s[0][3]+u[0][2]+u[0][3]:0)];v[1]=[($.boxModel?s[1][0]+s[1][1]+u[1][0]+u[1][1]:0),($.boxModel?s[1][2]+s[1][3]+u[1][2]+u[1][3]:0)];var w=[];w[0]={elem:h,left:{start:k.left,end:k.left+(m==E?l.width:0),units:'px'},width:{start:l.width-v[0][0],end:(n?l.width-v[0][0]:0),units:'px'},top:{start:k.top,end:k.top+(m==C?l.height:0),units:'px'},height:{start:l.height-v[0][1],end:(n?0:l.height-v[0][1]),units:'px'},paddingLeft:{start:u[0][0],end:(o?0:u[0][0]),units:'px'},paddingRight:{start:u[0][1],end:(o?0:u[0][1]),units:'px'},paddingTop:{start:u[0][2],end:(n?0:u[0][2]),units:'px'},paddingBottom:{start:u[0][3],end:(n?0:u[0][3]),units:'px'},borderLeftWidth:{start:s[0][0],end:(o?0:s[0][0]),units:'px'},borderRightWidth:{start:s[0][1],end:(o?0:s[0][1]),units:'px'},borderTopWidth:{start:s[0][2],end:(n?0:s[0][2]),units:'px'},borderBottomWidth:{start:s[0][3],end:(n?0:s[0][3]),units:'px'},lineHeight:{start:e.lineHeight[1],end:(n?e.lineHeight[0]:e.lineHeight[1]),units:'em'},letterSpacing:{start:e.letterSpacing[1],end:(n?e.letterSpacing[1]:e.letterSpacing[0]),units:'em'}};w[1]={elem:j,left:{start:k.left+(m==D?l.width:0),end:k.left,units:'px'},width:{start:(n?l.width-v[1][0]:0),end:l.width-v[1][0],units:'px'},top:{start:k.top+(m==B?l.height:0),end:k.top,units:'px'},height:{start:(n?($.browser.msie?1:0):l.height-v[1][1]),end:l.height-v[1][1],units:'px'},paddingLeft:{start:(o?0:u[1][0]),end:u[1][0],units:'px'},paddingRight:{start:(o?0:u[1][1]),end:u[1][1],units:'px'},paddingTop:{start:(n?0:u[1][2]),end:u[1][2],units:'px'},paddingBottom:{start:(n?0:u[1][3]),end:u[1][3],units:'px'},borderLeftWidth:{start:(o?0:s[1][0]),end:s[1][0],units:'px'},borderRightWidth:{start:(o?0:s[1][1]),end:s[1][1],units:'px'},borderTopWidth:{start:(n?0:s[1][2]),end:s[1][2],units:'px'},borderBottomWidth:{start:(n?0:s[1][3]),end:s[1][3],units:'px'},lineHeight:{start:(n?e.lineHeight[0]:e.lineHeight[1]),end:e.lineHeight[1],units:'em'},letterSpacing:{start:(n?e.letterSpacing[1]:e.letterSpacing[0]),end:e.letterSpacing[1],units:'em'}};if(!e.noShading){var x=function(a,b,c){return{elem:null,left:{start:a.left.start,end:a.left.end,units:'px'},width:{start:a.width.start,end:a.width.end,units:'px'},top:{start:a.top.start,end:a.top.end,units:'px'},height:{start:a.height.start,end:a.height.end,units:'px'},paddingLeft:{start:a.paddingLeft.start+a.borderLeftWidth.start,end:a.paddingLeft.end+a.borderLeftWidth.end,units:'px'},paddingRight:{start:a.paddingRight.start+a.borderRightWidth.start,end:a.paddingRight.end+a.borderRightWidth.end,units:'px'},paddingTop:{start:a.paddingTop.start+a.borderTopWidth.start,end:a.paddingTop.end+a.borderTopWidth.end,units:'px'},paddingBottom:{start:a.paddingBottom.start+a.borderBottomWidth.start,end:a.paddingBottom.end+a.borderBottomWidth.end,units:'px'},opacity:{start:b,end:c,units:''}}};w[2]=x(w[q?0:1],r,e.opacity[1]-r);w[3]=x(w[q?1:0],e.opacity[1]-r,r)}var y=function(a){return{left:a.left.start+'px',width:a.width.start+'px',top:a.top.start+'px',height:a.height.start+'px',lineHeight:a.lineHeight.start+'em',padding:a.paddingTop.start+'px '+a.paddingRight.start+'px '+a.paddingBottom.start+'px '+a.paddingLeft.start+'px',borderLeftWidth:a.borderLeftWidth.start+'px',borderRightWidth:a.borderRightWidth.start+'px',borderTopWidth:a.borderTopWidth.start+'px',borderBottomWidth:a.borderBottomWidth.start+'px',letterSpacing:a.letterSpacing.start+'em',overflow:'hidden'}};h.css(y(w[0]));j.css(y(w[1])).show();if(!e.noShading){w[2].elem=$(($.browser.msie?'<img src="'+e.imagePath+'imageCubeHigh.png"':'<div')+' class="imageCubeShading" style="background-color: white; opacity: '+r+'; z-index: 10; position: absolute; '+'left: '+w[2].left.start+'px; width: '+w[2].width.start+'px; '+'top: '+w[2].top.start+'px; height: '+w[2].height.start+'px; '+'padding: '+(q?h:j).css('padding')+';"'+($.browser.msie?'/>':'></div>'));w[3].elem=$(($.browser.msie?'<img src="'+e.imagePath+'imageCubeShad.png"':'<div')+' class="imageCubeShading" style="background-color: black; opacity: '+(e.opacity[1]-r)+'; z-index: 10; position: absolute; '+'left: '+w[3].left.start+'px; width: '+w[3].width.start+'px; '+'top: '+w[3].top.start+'px; height: '+w[3].height.start+'px; '+'padding: '+(q?j:h).css('padding')+';"'+($.browser.msie?'/>':'></div>'));d.append(w[2].elem).append(w[3].elem)}for(var i=0;i<w.length;i++){for(var z in w[i]){var A=w[i][z];A.diff=A.end-A.start}}return w}});function extendRemove(a,b){$.extend(a,b);for(var c in b){if(b[c]==null){a[c]=null}}return a}$.fn.imagecube=function(a){var b=Array.prototype.slice.call(arguments,1);if(a=='current'){return $.imagecube['_'+a+'ImageCube'].apply($.imagecube,[this[0]].concat(b))}return this.each(function(){if(typeof a=='string'){$.imagecube['_'+a+'ImageCube'].apply($.imagecube,[this].concat(b))}else{$.imagecube._attachImageCube(this,a)}})};$.fx.step[F]=function(a){if(a.state==0){a.start=0.0;a.end=1.0;a.stepProps=$.imagecube._prepareImageCube(a.elem);a.saveCSS={borderLeftWidth:a.stepProps[0].elem.css('borderLeftWidth'),borderRightWidth:a.stepProps[0].elem.css('borderRightWidth'),borderTopWidth:a.stepProps[0].elem.css('borderTopWidth'),borderBottomWidth:a.stepProps[0].elem.css('borderBottomWidth'),padding:a.stepProps[0].elem.css('padding')}}for(var i=0;i<a.stepProps.length;i++){var b={};for(var c in a.stepProps[i]){var d=a.stepProps[i][c];if(c!='elem'){b[c]=(a.pos*d.diff+d.start)+d.units}}a.stepProps[i].elem.css(b)}if(a.state==1){a.stepProps[0].elem.hide().css(a.saveCSS);if(a.stepProps.length>2){a.stepProps[2].elem.remove();a.stepProps[3].elem.remove()}$.imagecube._prepareRotation(a.elem)}};$.imagecube=new ImageCube()})(jQuery);